> For the complete documentation index, see [llms.txt](https://docs.mediarithmics.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mediarithmics.io/api-reference/datamart-management/runtime-schemas.md).

# Runtime Schemas

Operations related to **Runtime Schemas**, the GraphQL SDL configurations that define the data model of a Datamart, specifying which objects and fields are stored, structured, and indexed for querying. **Indexed fields** can be used in OTQL queries and segment building, while non-indexed fields remain stored but not queryable. Schema changes can be applied with historical data reindexing.

Relevant documentation:

* [Schema](https://userguides.mediarithmics.io/basics/key-concepts/what-is-a-data-schema)

## POST /datamarts/{datamart\_id}/graphdb\_runtime\_schemas/{schema\_id}/validation

> Validate runtime schema

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Runtime Schemas","description":"Operations related to **Runtime Schemas**, the GraphQL SDL configurations that define the data model of a Datamart, specifying which objects and fields are stored, structured, and indexed for querying. **Indexed fields** can be used in OTQL queries and segment building, while non-indexed fields remain stored but not queryable. Schema changes can be applied with historical data reindexing.\n\nRelevant documentation:\n- [Schema](https://userguides.mediarithmics.io/basics/key-concepts/what-is-a-data-schema)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/datamarts/{datamart_id}/graphdb_runtime_schemas/{schema_id}/validation":{"post":{"summary":"Validate runtime schema","parameters":[{"explode":false,"schema":{"type":"integer","format":"int64"},"required":true,"name":"datamart_id","style":"simple","description":"The datamart owning the schema.","in":"path"},{"in":"path","schema":{"type":"integer","format":"int64"},"required":true,"name":"schema_id","explode":false,"description":"The schema to validate.","style":"simple"}],"description":"","responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/RuntimeSchemaValidationInfoResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"tags":["Runtime Schemas"],"operationId":"validateRuntimeSchema"}}},"components":{"schemas":{"RuntimeSchemaValidationInfoResource":{"type":"object","properties":{"datamart_id":{"type":"string","readOnly":false},"schema_id":{"type":"string","readOnly":false},"tree_index_operations":{"type":"array","items":{"$ref":"#/components/schemas/TreeIndexValidationInfoResource"},"readOnly":false},"schema_errors":{"type":"array","items":{"$ref":"#/components/schemas/RuntimeSchemaValidationErrorRecord"},"readOnly":false}},"required":["datamart_id","schema_errors","schema_id","tree_index_operations"]},"TreeIndexValidationInfoResource":{"discriminator":{"propertyName":"type","mapping":{"ERROR":"#/components/schemas/TreeIndexInvalidInfoResource","VALID":"#/components/schemas/TreeIndexValidInfoResource"}},"oneOf":[{"$ref":"#/components/schemas/TreeIndexInvalidInfoResource"},{"$ref":"#/components/schemas/TreeIndexValidInfoResource"}],"properties":{"type":{"type":"string","enum":["ERROR","VALID"]}},"required":["type"]},"TreeIndexInvalidInfoResource":{"type":"object","properties":{"datamart_id":{"type":"string","readOnly":false},"index_selection_id":{"type":"string","readOnly":false},"error_code":{"$ref":"#/components/schemas/TreeIndexValidationError"},"error_message":{"type":"string","readOnly":false}},"required":["datamart_id","error_code","error_message","index_selection_id"]},"TreeIndexValidationError":{"type":"string","enum":["INDEX_JOB_STILL_RUNNING","DRIVER_NOT_COMPATIBLE","DRIVER_DEPRECATED"],"readOnly":false},"TreeIndexValidInfoResource":{"allOf":[{"$ref":"#/components/schemas/IndexDriverVersion"},{"type":"object","properties":{"current_index_size":{"$ref":"#/components/schemas/TreeIndexSize"},"new_index_size":{"$ref":"#/components/schemas/TreeIndexSize"},"current_index_id":{"type":"string","readOnly":false},"init_strategy":{"$ref":"#/components/schemas/TreeIndexInitStrategy"},"new_index":{"type":"boolean","default":false,"readOnly":false},"init_job":{"$ref":"#/components/schemas/TreeIndexJobType"},"index_name":{"type":"string","readOnly":false},"driver_version_minor_number":{"type":"integer","format":"int32","default":0,"readOnly":false},"datamart_id":{"type":"string","readOnly":false},"driver_version_major_number":{"type":"integer","format":"int32","default":0,"readOnly":false},"index_selection_id":{"type":"string","readOnly":false}},"required":["datamart_id","driver_version_major_number","driver_version_minor_number","index_name","index_selection_id","init_strategy","new_index"]}]},"IndexDriverVersion":{"type":"object"},"TreeIndexSize":{"type":"string","enum":["SMALL","MEDIUM","LARGE","X_LARGE","XX_LARGE","XXX_LARGE","EXTRA_LARGE","XXXX_LARGE"],"readOnly":false},"TreeIndexInitStrategy":{"type":"string","enum":["AUTOMATIC","FORCE_BUILD_FROM_CURSOR","FORCE_BUILD_FROM_INDEX","FORCE_NO_BUILD","MANUAL"],"readOnly":false},"TreeIndexJobType":{"type":"string","enum":["CURSOR_BASED_FULL_BUILD","INDEX_BASED_FULL_BUILD","IN_PLACE_REFRESH"],"readOnly":false},"RuntimeSchemaValidationErrorRecord":{"type":"object","properties":{"error_code":{"$ref":"#/components/schemas/RuntimeSchemaValidationError"},"error_message":{"type":"string","readOnly":false}},"required":["error_code"]},"RuntimeSchemaValidationError":{"type":"string","enum":["COMPILATION_ERROR"],"readOnly":false},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## GET /datamarts/{datamart\_id}/graphdb\_runtime\_schemas/{schema\_id}/object\_trees/{object\_tree\_id}/object\_type\_definitions/{object\_type\_definition\_id}/scalar\_fields/{scalar\_field\_id}

> Get scalar field

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Runtime Schemas","description":"Operations related to **Runtime Schemas**, the GraphQL SDL configurations that define the data model of a Datamart, specifying which objects and fields are stored, structured, and indexed for querying. **Indexed fields** can be used in OTQL queries and segment building, while non-indexed fields remain stored but not queryable. Schema changes can be applied with historical data reindexing.\n\nRelevant documentation:\n- [Schema](https://userguides.mediarithmics.io/basics/key-concepts/what-is-a-data-schema)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/datamarts/{datamart_id}/graphdb_runtime_schemas/{schema_id}/object_trees/{object_tree_id}/object_type_definitions/{object_type_definition_id}/scalar_fields/{scalar_field_id}":{"get":{"responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/ScalarFieldInfosResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"description":"","parameters":[{"required":true,"schema":{"type":"string"},"name":"datamart_id","in":"path","explode":false,"style":"simple"},{"schema":{"type":"string"},"in":"path","explode":false,"name":"schema_id","style":"simple","required":true},{"schema":{"type":"string"},"explode":false,"in":"path","required":true,"style":"simple","name":"object_tree_id"},{"in":"path","name":"object_type_definition_id","style":"simple","schema":{"type":"string"},"explode":false,"required":true},{"in":"path","schema":{"type":"string"},"style":"simple","required":true,"name":"scalar_field_id","explode":false}],"operationId":"getScalarField","summary":"Get scalar field","tags":["Runtime Schemas"]}}},"components":{"schemas":{"ScalarFieldInfosResource":{"type":"object","properties":{"cloned_from":{"type":"string","readOnly":false},"input_mapping":{"$ref":"#/components/schemas/FieldInputMappingResource"},"field_name":{"type":"string","readOnly":false},"optional":{"type":"boolean","default":false,"readOnly":false},"primary_key":{"type":"boolean","default":false,"readOnly":false},"id":{"type":"string","readOnly":true},"tree_index_data_type":{"$ref":"#/components/schemas/TreeIndexDataType"},"foreign_key":{"$ref":"#/components/schemas/FieldRef"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/FieldMappingResource"},"readOnly":true},"field_type":{"type":"string","readOnly":false},"tree_index":{"$ref":"#/components/schemas/ObjectTreeIndexResource"},"reference_table":{"$ref":"#/components/schemas/ReferenceTableResource"},"list":{"type":"boolean","default":false,"readOnly":false},"predefined":{"type":"boolean","default":false,"readOnly":true}},"required":["field_name","field_type","list","mappings","optional","predefined","primary_key"]},"FieldInputMappingResource":{"discriminator":{"propertyName":"type","mapping":{"DATA_WAREHOUSE":"#/components/schemas/DataWarehouse","JSON_DATA_STREAM":"#/components/schemas/JsonDataStream","CONVERT_FROM":"#/components/schemas/ConvertFrom1"}},"oneOf":[{"$ref":"#/components/schemas/DataWarehouse"},{"$ref":"#/components/schemas/JsonDataStream"},{"$ref":"#/components/schemas/ConvertFrom1"}],"properties":{"type":{"type":"string","enum":["DATA_WAREHOUSE","JSON_DATA_STREAM","CONVERT_FROM"]}},"required":["type"]},"DataWarehouse":{"type":"object","properties":{"data_warehouse_column_id":{"type":"string","readOnly":false}},"required":["data_warehouse_column_id"]},"JsonDataStream":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false}},"required":["json_path"]},"ConvertFrom1":{"type":"object","properties":{"field":{"$ref":"#/components/schemas/FieldRef"},"source_unit":{"$ref":"#/components/schemas/TimestampUnit"}},"required":["field"]},"FieldRef":{"discriminator":{"propertyName":"type","mapping":{"FIELD_NAME":"#/components/schemas/FieldName","FIELD_ID":"#/components/schemas/FieldId1"}},"oneOf":[{"$ref":"#/components/schemas/FieldName"},{"$ref":"#/components/schemas/FieldId1"}],"properties":{"type":{"type":"string","enum":["FIELD_NAME","FIELD_ID"]}},"required":["type"]},"FieldName":{"type":"object","properties":{"field_name":{"type":"string","readOnly":false}},"required":["field_name"]},"FieldId1":{"type":"object","properties":{"field_id":{"type":"string","readOnly":false}},"required":["field_id"]},"TimestampUnit":{"type":"string","enum":["SECOND","MILLISECOND","MICROSECOND","NANOSECOND"],"readOnly":false},"TreeIndexDataType":{"type":"string","enum":["TEXT","KEYWORD"],"readOnly":false},"FieldMappingResource":{"discriminator":{"propertyName":"type","mapping":{"CONVERT_FROM":"#/components/schemas/ConvertFrom","DATA_WAREHOUSE_COLUMN_BY_NAME":"#/components/schemas/DataWarehouseColumnByName","JSON_DATA_STREAM":"#/components/schemas/JsonPath","DATA_WAREHOUSE_COLUMN_BY_ID":"#/components/schemas/DataWarehouseColumnById1","JSON_PATH":"#/components/schemas/JsonPath","AUTO_GENERATED":"#/components/schemas/AutoGenerated"}},"oneOf":[{"$ref":"#/components/schemas/JsonPath"},{"$ref":"#/components/schemas/AutoGenerated"},{"$ref":"#/components/schemas/JsonPath"},{"$ref":"#/components/schemas/ConvertFrom"},{"$ref":"#/components/schemas/DataWarehouseColumnByName"},{"$ref":"#/components/schemas/DataWarehouseColumnById1"}],"properties":{"type":{"type":"string","enum":["JSON_PATH","AUTO_GENERATED","JSON_DATA_STREAM","CONVERT_FROM","DATA_WAREHOUSE_COLUMN_BY_NAME","DATA_WAREHOUSE_COLUMN_BY_ID"]}},"required":["type"]},"JsonPath":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["json_path","mapping_group_id"]},"AutoGenerated":{"type":"object","properties":{"strategy":{"$ref":"#/components/schemas/AutoGeneratedStrategy"},"mapping_group_id":{"type":"string","readOnly":false}},"required":["mapping_group_id","strategy"]},"AutoGeneratedStrategy":{"type":"string","enum":["INDEX","UUID"],"readOnly":false},"ConvertFrom":{"type":"object","properties":{"field":{"$ref":"#/components/schemas/FieldRef"},"source_unit":{"$ref":"#/components/schemas/TimestampUnit"},"mapping_group_id":{"type":"string","readOnly":false}},"required":["field","mapping_group_id"]},"DataWarehouseColumnByName":{"type":"object","properties":{"column_name":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["column_name","mapping_group_id"]},"DataWarehouseColumnById1":{"type":"object","properties":{"data_warehouse_column_id":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["data_warehouse_column_id","mapping_group_id"]},"ObjectTreeIndexResource":{"type":"object","properties":{"id":{"type":"string","readOnly":false},"name":{"type":"string","readOnly":false}},"required":["name"]},"ReferenceTableResource":{"type":"object","properties":{"id":{"type":"string","readOnly":false},"type":{"$ref":"#/components/schemas/ReferenceTableType"},"model_type":{"type":"string","readOnly":false}},"required":["model_type","type"]},"ReferenceTableType":{"type":"string","enum":["CORE_OBJECT","STATIC","SYSTEM_ENUM","DISCOVERED"],"readOnly":false},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## PUT /datamarts/{datamart\_id}/graphdb\_runtime\_schemas/{schema\_id}/object\_trees/{object\_tree\_id}/object\_type\_definitions/{object\_type\_definition\_id}/scalar\_fields/{scalar\_field\_id}

> Update scalar field

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Runtime Schemas","description":"Operations related to **Runtime Schemas**, the GraphQL SDL configurations that define the data model of a Datamart, specifying which objects and fields are stored, structured, and indexed for querying. **Indexed fields** can be used in OTQL queries and segment building, while non-indexed fields remain stored but not queryable. Schema changes can be applied with historical data reindexing.\n\nRelevant documentation:\n- [Schema](https://userguides.mediarithmics.io/basics/key-concepts/what-is-a-data-schema)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/datamarts/{datamart_id}/graphdb_runtime_schemas/{schema_id}/object_trees/{object_tree_id}/object_type_definitions/{object_type_definition_id}/scalar_fields/{scalar_field_id}":{"put":{"responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/ScalarFieldInfosResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"parameters":[{"in":"path","style":"simple","required":true,"name":"datamart_id","schema":{"type":"string"},"explode":false},{"explode":false,"schema":{"type":"string"},"in":"path","required":true,"style":"simple","name":"schema_id"},{"explode":false,"schema":{"type":"string"},"in":"path","required":true,"style":"simple","name":"object_tree_id"},{"style":"simple","name":"object_type_definition_id","schema":{"type":"string"},"explode":false,"required":true,"in":"path"},{"required":true,"explode":false,"in":"path","style":"simple","name":"scalar_field_id","schema":{"type":"string"}}],"operationId":"updateScalarField","summary":"Update scalar field","tags":["Runtime Schemas"],"requestBody":{"description":"The relationship to update","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ScalarFieldInfosResource"}}},"required":true},"description":""}}},"components":{"schemas":{"ScalarFieldInfosResource":{"type":"object","properties":{"cloned_from":{"type":"string","readOnly":false},"input_mapping":{"$ref":"#/components/schemas/FieldInputMappingResource"},"field_name":{"type":"string","readOnly":false},"optional":{"type":"boolean","default":false,"readOnly":false},"primary_key":{"type":"boolean","default":false,"readOnly":false},"id":{"type":"string","readOnly":true},"tree_index_data_type":{"$ref":"#/components/schemas/TreeIndexDataType"},"foreign_key":{"$ref":"#/components/schemas/FieldRef"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/FieldMappingResource"},"readOnly":true},"field_type":{"type":"string","readOnly":false},"tree_index":{"$ref":"#/components/schemas/ObjectTreeIndexResource"},"reference_table":{"$ref":"#/components/schemas/ReferenceTableResource"},"list":{"type":"boolean","default":false,"readOnly":false},"predefined":{"type":"boolean","default":false,"readOnly":true}},"required":["field_name","field_type","list","mappings","optional","predefined","primary_key"]},"FieldInputMappingResource":{"discriminator":{"propertyName":"type","mapping":{"DATA_WAREHOUSE":"#/components/schemas/DataWarehouse","JSON_DATA_STREAM":"#/components/schemas/JsonDataStream","CONVERT_FROM":"#/components/schemas/ConvertFrom1"}},"oneOf":[{"$ref":"#/components/schemas/DataWarehouse"},{"$ref":"#/components/schemas/JsonDataStream"},{"$ref":"#/components/schemas/ConvertFrom1"}],"properties":{"type":{"type":"string","enum":["DATA_WAREHOUSE","JSON_DATA_STREAM","CONVERT_FROM"]}},"required":["type"]},"DataWarehouse":{"type":"object","properties":{"data_warehouse_column_id":{"type":"string","readOnly":false}},"required":["data_warehouse_column_id"]},"JsonDataStream":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false}},"required":["json_path"]},"ConvertFrom1":{"type":"object","properties":{"field":{"$ref":"#/components/schemas/FieldRef"},"source_unit":{"$ref":"#/components/schemas/TimestampUnit"}},"required":["field"]},"FieldRef":{"discriminator":{"propertyName":"type","mapping":{"FIELD_NAME":"#/components/schemas/FieldName","FIELD_ID":"#/components/schemas/FieldId1"}},"oneOf":[{"$ref":"#/components/schemas/FieldName"},{"$ref":"#/components/schemas/FieldId1"}],"properties":{"type":{"type":"string","enum":["FIELD_NAME","FIELD_ID"]}},"required":["type"]},"FieldName":{"type":"object","properties":{"field_name":{"type":"string","readOnly":false}},"required":["field_name"]},"FieldId1":{"type":"object","properties":{"field_id":{"type":"string","readOnly":false}},"required":["field_id"]},"TimestampUnit":{"type":"string","enum":["SECOND","MILLISECOND","MICROSECOND","NANOSECOND"],"readOnly":false},"TreeIndexDataType":{"type":"string","enum":["TEXT","KEYWORD"],"readOnly":false},"FieldMappingResource":{"discriminator":{"propertyName":"type","mapping":{"CONVERT_FROM":"#/components/schemas/ConvertFrom","DATA_WAREHOUSE_COLUMN_BY_NAME":"#/components/schemas/DataWarehouseColumnByName","JSON_DATA_STREAM":"#/components/schemas/JsonPath","DATA_WAREHOUSE_COLUMN_BY_ID":"#/components/schemas/DataWarehouseColumnById1","JSON_PATH":"#/components/schemas/JsonPath","AUTO_GENERATED":"#/components/schemas/AutoGenerated"}},"oneOf":[{"$ref":"#/components/schemas/JsonPath"},{"$ref":"#/components/schemas/AutoGenerated"},{"$ref":"#/components/schemas/JsonPath"},{"$ref":"#/components/schemas/ConvertFrom"},{"$ref":"#/components/schemas/DataWarehouseColumnByName"},{"$ref":"#/components/schemas/DataWarehouseColumnById1"}],"properties":{"type":{"type":"string","enum":["JSON_PATH","AUTO_GENERATED","JSON_DATA_STREAM","CONVERT_FROM","DATA_WAREHOUSE_COLUMN_BY_NAME","DATA_WAREHOUSE_COLUMN_BY_ID"]}},"required":["type"]},"JsonPath":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["json_path","mapping_group_id"]},"AutoGenerated":{"type":"object","properties":{"strategy":{"$ref":"#/components/schemas/AutoGeneratedStrategy"},"mapping_group_id":{"type":"string","readOnly":false}},"required":["mapping_group_id","strategy"]},"AutoGeneratedStrategy":{"type":"string","enum":["INDEX","UUID"],"readOnly":false},"ConvertFrom":{"type":"object","properties":{"field":{"$ref":"#/components/schemas/FieldRef"},"source_unit":{"$ref":"#/components/schemas/TimestampUnit"},"mapping_group_id":{"type":"string","readOnly":false}},"required":["field","mapping_group_id"]},"DataWarehouseColumnByName":{"type":"object","properties":{"column_name":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["column_name","mapping_group_id"]},"DataWarehouseColumnById1":{"type":"object","properties":{"data_warehouse_column_id":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["data_warehouse_column_id","mapping_group_id"]},"ObjectTreeIndexResource":{"type":"object","properties":{"id":{"type":"string","readOnly":false},"name":{"type":"string","readOnly":false}},"required":["name"]},"ReferenceTableResource":{"type":"object","properties":{"id":{"type":"string","readOnly":false},"type":{"$ref":"#/components/schemas/ReferenceTableType"},"model_type":{"type":"string","readOnly":false}},"required":["model_type","type"]},"ReferenceTableType":{"type":"string","enum":["CORE_OBJECT","STATIC","SYSTEM_ENUM","DISCOVERED"],"readOnly":false},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## DELETE /datamarts/{datamart\_id}/graphdb\_runtime\_schemas/{schema\_id}/object\_trees/{object\_tree\_id}/object\_type\_definitions/{object\_type\_definition\_id}/scalar\_fields/{scalar\_field\_id}

> Delete scalar field

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Runtime Schemas","description":"Operations related to **Runtime Schemas**, the GraphQL SDL configurations that define the data model of a Datamart, specifying which objects and fields are stored, structured, and indexed for querying. **Indexed fields** can be used in OTQL queries and segment building, while non-indexed fields remain stored but not queryable. Schema changes can be applied with historical data reindexing.\n\nRelevant documentation:\n- [Schema](https://userguides.mediarithmics.io/basics/key-concepts/what-is-a-data-schema)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/datamarts/{datamart_id}/graphdb_runtime_schemas/{schema_id}/object_trees/{object_tree_id}/object_type_definitions/{object_type_definition_id}/scalar_fields/{scalar_field_id}":{"delete":{"responses":{"200":{"$ref":"#/components/responses/simple"},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"operationId":"deleteScalarField","description":"","summary":"Delete scalar field","tags":["Runtime Schemas"],"parameters":[{"schema":{"type":"string"},"required":true,"explode":false,"in":"path","style":"simple","name":"datamart_id"},{"explode":false,"name":"schema_id","in":"path","required":true,"schema":{"type":"string"},"style":"simple"},{"explode":false,"in":"path","style":"simple","name":"object_tree_id","required":true,"schema":{"type":"string"}},{"schema":{"type":"string"},"required":true,"in":"path","name":"object_type_definition_id","explode":false,"style":"simple"},{"schema":{"type":"string"},"in":"path","style":"simple","explode":false,"name":"scalar_field_id","required":true}]}}},"components":{"responses":{"simple":{"description":"Success response","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]}},"required":["status"]}}}},"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}},"schemas":{"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}}}}
```

## GET /datamarts/{datamart\_id}/graphdb\_runtime\_schemas/{schema\_id}/object\_trees/{object\_tree\_id}

> Get object tree

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Runtime Schemas","description":"Operations related to **Runtime Schemas**, the GraphQL SDL configurations that define the data model of a Datamart, specifying which objects and fields are stored, structured, and indexed for querying. **Indexed fields** can be used in OTQL queries and segment building, while non-indexed fields remain stored but not queryable. Schema changes can be applied with historical data reindexing.\n\nRelevant documentation:\n- [Schema](https://userguides.mediarithmics.io/basics/key-concepts/what-is-a-data-schema)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/datamarts/{datamart_id}/graphdb_runtime_schemas/{schema_id}/object_trees/{object_tree_id}":{"get":{"responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/ObjectTreeInfosResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"parameters":[{"style":"simple","explode":false,"name":"datamart_id","required":true,"in":"path","schema":{"type":"string"}},{"schema":{"type":"string"},"in":"path","name":"schema_id","explode":false,"required":true,"style":"simple"},{"required":true,"name":"object_tree_id","style":"simple","in":"path","schema":{"type":"string"},"explode":false},{"schema":{"$ref":"#/components/schemas/FieldRefFormat"},"required":false,"name":"field_ref_format","style":"form","in":"query","explode":true}],"summary":"Get object tree","description":"","tags":["Runtime Schemas"],"operationId":"getObjectTree"}}},"components":{"schemas":{"ObjectTreeInfosResource":{"type":"object","properties":{"id":{"type":"string","readOnly":true},"input_stream_configs":{"type":"array","items":{"$ref":"#/components/schemas/InputStreamConfigResource"},"readOnly":false},"relation_cardinality":{"$ref":"#/components/schemas/RelationshipCardinality"},"relation_name":{"type":"string","readOnly":false},"data_source_type":{"$ref":"#/components/schemas/ObjectTreeDataSourceType"},"data_warehouse_id":{"type":"string","readOnly":false},"channel_source":{"$ref":"#/components/schemas/ObjectTreeChannelSourceResource"},"computed_field_technical_name":{"type":"string","readOnly":false},"data_warehouse_live_ingestion_config":{"$ref":"#/components/schemas/ObjectTreeDataWarehouseLiveIngestionConfigResource"},"description":{"type":"string","readOnly":false},"cloned_from":{"type":"string","readOnly":false},"name":{"type":"string","readOnly":false},"datamart_schema_id":{"type":"string","readOnly":false},"object_type_definition":{"$ref":"#/components/schemas/ObjectTypeDefinitionInfosResource"},"user_identifiers":{"type":"array","items":{"$ref":"#/components/schemas/Generic"},"readOnly":false},"event_name":{"$ref":"#/components/schemas/ObjectTreeEventNameResource"},"object_tree_type":{"$ref":"#/components/schemas/ObjectTreeType"},"activity_type":{"$ref":"#/components/schemas/ObjectTreeActivityType"}},"required":["data_source_type","datamart_schema_id","description","id","input_stream_configs","name","object_tree_type","relation_cardinality","relation_name","user_identifiers"]},"InputStreamConfigResource":{"type":"object","properties":{"working_table_name":{"type":"string","readOnly":true},"strategy":{"$ref":"#/components/schemas/CursorStrategy"},"data_warehouse_table_id":{"type":"string","readOnly":false},"object_type_definition_id":{"type":"string","readOnly":false},"use_processing_pipeline":{"type":"boolean","default":false,"readOnly":false},"document_import_id":{"type":"string","readOnly":true},"scheduling":{"$ref":"#/components/schemas/Scheduling"}},"required":["data_warehouse_table_id","document_import_id","scheduling","strategy","use_processing_pipeline"]},"CursorStrategy":{"discriminator":{"propertyName":"type","mapping":{"MODIFIED_TS":"#/components/schemas/ModifiedTs","HASH_TABLE":"#/components/schemas/HashTable","LOG":"#/components/schemas/Log","FULL_IMPORT":"#/components/schemas/FullImport"}},"oneOf":[{"$ref":"#/components/schemas/ModifiedTs"},{"$ref":"#/components/schemas/HashTable"},{"$ref":"#/components/schemas/Log"},{"$ref":"#/components/schemas/FullImport"}],"properties":{"type":{"type":"string","enum":["MODIFIED_TS","HASH_TABLE","LOG","FULL_IMPORT"]}},"required":["type"]},"ModifiedTs":{"type":"object","properties":{"ts_column":{"type":"string","readOnly":false},"from":{"type":"integer","format":"int64","default":0,"readOnly":false},"unit":{"$ref":"#/components/schemas/TimestampUnit"}},"required":["ts_column"]},"TimestampUnit":{"type":"string","enum":["SECOND","MILLISECOND","MICROSECOND","NANOSECOND"],"readOnly":false},"HashTable":{"type":"object","properties":{"column_ids":{"type":"array","items":{"type":"string","readOnly":false},"readOnly":false}},"required":["column_ids"]},"Log":{"type":"object","properties":{"ts_column":{"type":"string","readOnly":false},"from":{"type":"integer","format":"int64","default":0,"readOnly":false},"unit":{"$ref":"#/components/schemas/TimestampUnit"}},"required":["ts_column"]},"FullImport":{"type":"object"},"Scheduling":{"discriminator":{"propertyName":"type","mapping":{"FREQUENCY":"#/components/schemas/Frequency"}},"oneOf":[{"$ref":"#/components/schemas/Frequency"}],"properties":{"type":{"type":"string","enum":["FREQUENCY"]}},"required":["type"]},"Frequency":{"type":"object","properties":{"start_hour":{"type":"integer","format":"int32","default":0,"readOnly":false},"unit":{"$ref":"#/components/schemas/SchedulingUnit"},"time_zone":{"type":"string","readOnly":true},"end_hour":{"type":"integer","format":"int32","default":0,"readOnly":false},"value":{"type":"integer","format":"int32","default":0,"readOnly":false}},"required":["time_zone","unit","value"]},"SchedulingUnit":{"type":"string","enum":["MINUTE","HOUR","DAY"],"readOnly":false},"RelationshipCardinality":{"type":"string","enum":["ONE_TO_ONE","ONE_TO_ZERO_OR_ONE","ONE_TO_MANY"],"readOnly":false},"ObjectTreeDataSourceType":{"type":"string","enum":["DATA_WAREHOUSE","JSON_DATA_STREAM","PREDEFINED","EDGE","COMPUTED_FIELD"],"readOnly":false},"ObjectTreeChannelSourceResource":{"discriminator":{"propertyName":"type","mapping":{"STATIC":"#/components/schemas/Static1","MAPPING":"#/components/schemas/Mapping"}},"oneOf":[{"$ref":"#/components/schemas/Static1"},{"$ref":"#/components/schemas/Mapping"}],"properties":{"type":{"type":"string","enum":["STATIC","MAPPING"]}},"required":["type"]},"Static1":{"type":"object","properties":{"id":{"type":"string","readOnly":true},"channel_id":{"type":"string","readOnly":false}},"required":["channel_id"]},"Mapping":{"type":"object","properties":{"id":{"type":"string","readOnly":true},"column_id":{"type":"string","readOnly":false}},"required":["column_id"]},"ObjectTreeDataWarehouseLiveIngestionConfigResource":{"type":"object","properties":{"id":{"type":"string","readOnly":true},"datamart_id":{"type":"string","readOnly":false},"name":{"type":"string","readOnly":false},"status":{"$ref":"#/components/schemas/ObjectTreeDataWarehouseLiveIngestionStatus"},"object_tree_id":{"type":"string","readOnly":false},"creation_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"bucket_name":{"type":"string","readOnly":false},"data_warehouse_id":{"type":"string","readOnly":false}},"required":["bucket_name","creation_ts","data_warehouse_id","datamart_id","id","name","object_tree_id","status"]},"ObjectTreeDataWarehouseLiveIngestionStatus":{"type":"string","enum":["WAITING_FOR_TABLE_CREATION","PAUSED","ACTIVE"],"readOnly":false},"ObjectTypeDefinitionInfosResource":{"type":"object","properties":{"input_mapping_path":{"type":"string","readOnly":false},"update_value_object":{"type":"boolean","default":false,"readOnly":false},"object_name":{"type":"string","readOnly":false},"id":{"type":"string","readOnly":true},"relationships":{"type":"array","items":{"$ref":"#/components/schemas/RelationshipInfosResource"},"readOnly":false},"cloned_from":{"type":"string","readOnly":false},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/ObjectTypeMappingResource"},"readOnly":true},"fields":{"type":"array","items":{"$ref":"#/components/schemas/ScalarFieldInfosResource"},"readOnly":false},"input_mapping_table":{"type":"string","readOnly":false},"input_mapping_column":{"type":"string","readOnly":false}},"required":["fields","id","mappings","object_name","relationships","update_value_object"]},"RelationshipInfosResource":{"type":"object","properties":{"relation_name":{"type":"string","readOnly":false},"cloned_from":{"type":"string","readOnly":false},"cardinality":{"$ref":"#/components/schemas/RelationshipCardinality"},"id":{"type":"string","readOnly":true},"child":{"$ref":"#/components/schemas/ObjectTypeDefinitionInfosResource"}},"required":["cardinality","relation_name"]},"ObjectTypeMappingResource":{"discriminator":{"propertyName":"type","mapping":{"DATA_WAREHOUSE_COLUMN_BY_NAME":"#/components/schemas/DataWarehouseColumnByName1","DATA_WAREHOUSE_TABLE_BY_ID":"#/components/schemas/DataWarehouseTableById","JSON_PATH":"#/components/schemas/JsonPath1","DATA_WAREHOUSE_COLUMN_BY_ID":"#/components/schemas/DataWarehouseColumnById","DATA_WAREHOUSE_TABLE_BY_NAME":"#/components/schemas/DataWarehouseTableByName"}},"oneOf":[{"$ref":"#/components/schemas/DataWarehouseTableById"},{"$ref":"#/components/schemas/JsonPath1"},{"$ref":"#/components/schemas/DataWarehouseTableByName"},{"$ref":"#/components/schemas/DataWarehouseColumnByName1"},{"$ref":"#/components/schemas/DataWarehouseColumnById"}],"properties":{"type":{"type":"string","enum":["DATA_WAREHOUSE_TABLE_BY_ID","JSON_PATH","DATA_WAREHOUSE_TABLE_BY_NAME","DATA_WAREHOUSE_COLUMN_BY_NAME","DATA_WAREHOUSE_COLUMN_BY_ID"]}},"required":["type"]},"DataWarehouseTableById":{"type":"object","properties":{"table_id":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["mapping_group_id","table_id"]},"JsonPath1":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["json_path","mapping_group_id"]},"DataWarehouseTableByName":{"type":"object","properties":{"table_name":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["mapping_group_id","table_name"]},"DataWarehouseColumnByName1":{"type":"object","properties":{"column_name":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["column_name","mapping_group_id"]},"DataWarehouseColumnById":{"type":"object","properties":{"column_id":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["column_id","mapping_group_id"]},"ScalarFieldInfosResource":{"type":"object","properties":{"cloned_from":{"type":"string","readOnly":false},"input_mapping":{"$ref":"#/components/schemas/FieldInputMappingResource"},"field_name":{"type":"string","readOnly":false},"optional":{"type":"boolean","default":false,"readOnly":false},"primary_key":{"type":"boolean","default":false,"readOnly":false},"id":{"type":"string","readOnly":true},"tree_index_data_type":{"$ref":"#/components/schemas/TreeIndexDataType"},"foreign_key":{"$ref":"#/components/schemas/FieldRef"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/FieldMappingResource"},"readOnly":true},"field_type":{"type":"string","readOnly":false},"tree_index":{"$ref":"#/components/schemas/ObjectTreeIndexResource"},"reference_table":{"$ref":"#/components/schemas/ReferenceTableResource"},"list":{"type":"boolean","default":false,"readOnly":false},"predefined":{"type":"boolean","default":false,"readOnly":true}},"required":["field_name","field_type","list","mappings","optional","predefined","primary_key"]},"FieldInputMappingResource":{"discriminator":{"propertyName":"type","mapping":{"DATA_WAREHOUSE":"#/components/schemas/DataWarehouse","JSON_DATA_STREAM":"#/components/schemas/JsonDataStream","CONVERT_FROM":"#/components/schemas/ConvertFrom1"}},"oneOf":[{"$ref":"#/components/schemas/DataWarehouse"},{"$ref":"#/components/schemas/JsonDataStream"},{"$ref":"#/components/schemas/ConvertFrom1"}],"properties":{"type":{"type":"string","enum":["DATA_WAREHOUSE","JSON_DATA_STREAM","CONVERT_FROM"]}},"required":["type"]},"DataWarehouse":{"type":"object","properties":{"data_warehouse_column_id":{"type":"string","readOnly":false}},"required":["data_warehouse_column_id"]},"JsonDataStream":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false}},"required":["json_path"]},"ConvertFrom1":{"type":"object","properties":{"field":{"$ref":"#/components/schemas/FieldRef"},"source_unit":{"$ref":"#/components/schemas/TimestampUnit"}},"required":["field"]},"FieldRef":{"discriminator":{"propertyName":"type","mapping":{"FIELD_NAME":"#/components/schemas/FieldName","FIELD_ID":"#/components/schemas/FieldId1"}},"oneOf":[{"$ref":"#/components/schemas/FieldName"},{"$ref":"#/components/schemas/FieldId1"}],"properties":{"type":{"type":"string","enum":["FIELD_NAME","FIELD_ID"]}},"required":["type"]},"FieldName":{"type":"object","properties":{"field_name":{"type":"string","readOnly":false}},"required":["field_name"]},"FieldId1":{"type":"object","properties":{"field_id":{"type":"string","readOnly":false}},"required":["field_id"]},"TreeIndexDataType":{"type":"string","enum":["TEXT","KEYWORD"],"readOnly":false},"FieldMappingResource":{"discriminator":{"propertyName":"type","mapping":{"CONVERT_FROM":"#/components/schemas/ConvertFrom","DATA_WAREHOUSE_COLUMN_BY_NAME":"#/components/schemas/DataWarehouseColumnByName","JSON_DATA_STREAM":"#/components/schemas/JsonPath","DATA_WAREHOUSE_COLUMN_BY_ID":"#/components/schemas/DataWarehouseColumnById1","JSON_PATH":"#/components/schemas/JsonPath","AUTO_GENERATED":"#/components/schemas/AutoGenerated"}},"oneOf":[{"$ref":"#/components/schemas/JsonPath"},{"$ref":"#/components/schemas/AutoGenerated"},{"$ref":"#/components/schemas/JsonPath"},{"$ref":"#/components/schemas/ConvertFrom"},{"$ref":"#/components/schemas/DataWarehouseColumnByName"},{"$ref":"#/components/schemas/DataWarehouseColumnById1"}],"properties":{"type":{"type":"string","enum":["JSON_PATH","AUTO_GENERATED","JSON_DATA_STREAM","CONVERT_FROM","DATA_WAREHOUSE_COLUMN_BY_NAME","DATA_WAREHOUSE_COLUMN_BY_ID"]}},"required":["type"]},"JsonPath":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["json_path","mapping_group_id"]},"AutoGenerated":{"type":"object","properties":{"strategy":{"$ref":"#/components/schemas/AutoGeneratedStrategy"},"mapping_group_id":{"type":"string","readOnly":false}},"required":["mapping_group_id","strategy"]},"AutoGeneratedStrategy":{"type":"string","enum":["INDEX","UUID"],"readOnly":false},"ConvertFrom":{"type":"object","properties":{"field":{"$ref":"#/components/schemas/FieldRef"},"source_unit":{"$ref":"#/components/schemas/TimestampUnit"},"mapping_group_id":{"type":"string","readOnly":false}},"required":["field","mapping_group_id"]},"DataWarehouseColumnByName":{"type":"object","properties":{"column_name":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["column_name","mapping_group_id"]},"DataWarehouseColumnById1":{"type":"object","properties":{"data_warehouse_column_id":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["data_warehouse_column_id","mapping_group_id"]},"ObjectTreeIndexResource":{"type":"object","properties":{"id":{"type":"string","readOnly":false},"name":{"type":"string","readOnly":false}},"required":["name"]},"ReferenceTableResource":{"type":"object","properties":{"id":{"type":"string","readOnly":false},"type":{"$ref":"#/components/schemas/ReferenceTableType"},"model_type":{"type":"string","readOnly":false}},"required":["model_type","type"]},"ReferenceTableType":{"type":"string","enum":["CORE_OBJECT","STATIC","SYSTEM_ENUM","DISCOVERED"],"readOnly":false},"Generic":{"allOf":[{"$ref":"#/components/schemas/ObjectTreeIdentifierResource"},{"type":"object","properties":{"id":{"type":"string","readOnly":true},"main":{"type":"boolean","default":false,"readOnly":false},"realm_id":{"type":"string","readOnly":false},"location":{"$ref":"#/components/schemas/ObjectTreeIdentifierLocationResource"},"identifier_type":{"$ref":"#/components/schemas/IdentifierType"}},"required":["id","identifier_type","main"]}]},"ObjectTreeIdentifierResource":{"type":"object"},"ObjectTreeIdentifierLocationResource":{"discriminator":{"propertyName":"type","mapping":{"COLUMN_LOCATION":"#/components/schemas/ObjectTreeIdentifierColumnLocationResource","FIELD_LOCATION":"#/components/schemas/ObjectTreeIdentifierFieldLocationResource"}},"oneOf":[{"$ref":"#/components/schemas/ObjectTreeIdentifierColumnLocationResource"},{"$ref":"#/components/schemas/ObjectTreeIdentifierFieldLocationResource"}],"properties":{"type":{"type":"string","enum":["COLUMN_LOCATION","FIELD_LOCATION"]}},"required":["type"]},"ObjectTreeIdentifierColumnLocationResource":{"type":"object","properties":{"column_id":{"type":"string","readOnly":false}},"required":["column_id"]},"ObjectTreeIdentifierFieldLocationResource":{"type":"object","properties":{"field_id":{"type":"string","readOnly":false}},"required":["field_id"]},"IdentifierType":{"type":"string","enum":["EMAIL_HASH","USER_ACCOUNT","USER_POINT_ID","DEVICE_POINT","DEVICE_TECHNICAL_ID"],"readOnly":false},"ObjectTreeEventNameResource":{"discriminator":{"propertyName":"type","mapping":{"STATIC":"#/components/schemas/Static","MAPPING":"#/components/schemas/Mapping1"}},"oneOf":[{"$ref":"#/components/schemas/Static"},{"$ref":"#/components/schemas/Mapping1"}],"properties":{"type":{"type":"string","enum":["STATIC","MAPPING"]}},"required":["type"]},"Static":{"type":"object","properties":{"id":{"type":"string","readOnly":true},"event_name":{"type":"string","readOnly":false}},"required":["event_name"]},"Mapping1":{"type":"object","properties":{"id":{"type":"string","readOnly":true},"column_id":{"type":"string","readOnly":false}},"required":["column_id"]},"ObjectTreeType":{"type":"string","enum":["Custom","ClusteringCohort","UserAccount","UserActivity","UserChoice","UserDevicePoint","UserEmail","UserEvent","UserProfile","UserScenario","UserSegment"],"readOnly":false},"ObjectTreeActivityType":{"type":"string","enum":["TOUCH","SITE_VISIT","APP_VISIT","CTV_VISIT"],"readOnly":false},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]},"FieldRefFormat":{"type":"string","enum":["ID","NAME"],"readOnly":false}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## PUT /datamarts/{datamart\_id}/graphdb\_runtime\_schemas/{schema\_id}/object\_trees/{object\_tree\_id}

> Get object types

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Runtime Schemas","description":"Operations related to **Runtime Schemas**, the GraphQL SDL configurations that define the data model of a Datamart, specifying which objects and fields are stored, structured, and indexed for querying. **Indexed fields** can be used in OTQL queries and segment building, while non-indexed fields remain stored but not queryable. Schema changes can be applied with historical data reindexing.\n\nRelevant documentation:\n- [Schema](https://userguides.mediarithmics.io/basics/key-concepts/what-is-a-data-schema)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/datamarts/{datamart_id}/graphdb_runtime_schemas/{schema_id}/object_trees/{object_tree_id}":{"put":{"description":"","operationId":"updateObjectTree","summary":"Get object types","parameters":[{"name":"datamart_id","required":true,"style":"simple","schema":{"type":"string"},"explode":false,"in":"path"},{"style":"simple","in":"path","name":"schema_id","schema":{"type":"string"},"explode":false,"required":true},{"required":true,"schema":{"type":"string"},"style":"simple","in":"path","name":"object_tree_id","explode":false}],"requestBody":{"description":"The datamart to create","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ObjectTreeInfosResource"}}},"required":true},"responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/ObjectTreeInfosResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"tags":["Runtime Schemas"]}}},"components":{"schemas":{"ObjectTreeInfosResource":{"type":"object","properties":{"id":{"type":"string","readOnly":true},"input_stream_configs":{"type":"array","items":{"$ref":"#/components/schemas/InputStreamConfigResource"},"readOnly":false},"relation_cardinality":{"$ref":"#/components/schemas/RelationshipCardinality"},"relation_name":{"type":"string","readOnly":false},"data_source_type":{"$ref":"#/components/schemas/ObjectTreeDataSourceType"},"data_warehouse_id":{"type":"string","readOnly":false},"channel_source":{"$ref":"#/components/schemas/ObjectTreeChannelSourceResource"},"computed_field_technical_name":{"type":"string","readOnly":false},"data_warehouse_live_ingestion_config":{"$ref":"#/components/schemas/ObjectTreeDataWarehouseLiveIngestionConfigResource"},"description":{"type":"string","readOnly":false},"cloned_from":{"type":"string","readOnly":false},"name":{"type":"string","readOnly":false},"datamart_schema_id":{"type":"string","readOnly":false},"object_type_definition":{"$ref":"#/components/schemas/ObjectTypeDefinitionInfosResource"},"user_identifiers":{"type":"array","items":{"$ref":"#/components/schemas/Generic"},"readOnly":false},"event_name":{"$ref":"#/components/schemas/ObjectTreeEventNameResource"},"object_tree_type":{"$ref":"#/components/schemas/ObjectTreeType"},"activity_type":{"$ref":"#/components/schemas/ObjectTreeActivityType"}},"required":["data_source_type","datamart_schema_id","description","id","input_stream_configs","name","object_tree_type","relation_cardinality","relation_name","user_identifiers"]},"InputStreamConfigResource":{"type":"object","properties":{"working_table_name":{"type":"string","readOnly":true},"strategy":{"$ref":"#/components/schemas/CursorStrategy"},"data_warehouse_table_id":{"type":"string","readOnly":false},"object_type_definition_id":{"type":"string","readOnly":false},"use_processing_pipeline":{"type":"boolean","default":false,"readOnly":false},"document_import_id":{"type":"string","readOnly":true},"scheduling":{"$ref":"#/components/schemas/Scheduling"}},"required":["data_warehouse_table_id","document_import_id","scheduling","strategy","use_processing_pipeline"]},"CursorStrategy":{"discriminator":{"propertyName":"type","mapping":{"MODIFIED_TS":"#/components/schemas/ModifiedTs","HASH_TABLE":"#/components/schemas/HashTable","LOG":"#/components/schemas/Log","FULL_IMPORT":"#/components/schemas/FullImport"}},"oneOf":[{"$ref":"#/components/schemas/ModifiedTs"},{"$ref":"#/components/schemas/HashTable"},{"$ref":"#/components/schemas/Log"},{"$ref":"#/components/schemas/FullImport"}],"properties":{"type":{"type":"string","enum":["MODIFIED_TS","HASH_TABLE","LOG","FULL_IMPORT"]}},"required":["type"]},"ModifiedTs":{"type":"object","properties":{"ts_column":{"type":"string","readOnly":false},"from":{"type":"integer","format":"int64","default":0,"readOnly":false},"unit":{"$ref":"#/components/schemas/TimestampUnit"}},"required":["ts_column"]},"TimestampUnit":{"type":"string","enum":["SECOND","MILLISECOND","MICROSECOND","NANOSECOND"],"readOnly":false},"HashTable":{"type":"object","properties":{"column_ids":{"type":"array","items":{"type":"string","readOnly":false},"readOnly":false}},"required":["column_ids"]},"Log":{"type":"object","properties":{"ts_column":{"type":"string","readOnly":false},"from":{"type":"integer","format":"int64","default":0,"readOnly":false},"unit":{"$ref":"#/components/schemas/TimestampUnit"}},"required":["ts_column"]},"FullImport":{"type":"object"},"Scheduling":{"discriminator":{"propertyName":"type","mapping":{"FREQUENCY":"#/components/schemas/Frequency"}},"oneOf":[{"$ref":"#/components/schemas/Frequency"}],"properties":{"type":{"type":"string","enum":["FREQUENCY"]}},"required":["type"]},"Frequency":{"type":"object","properties":{"start_hour":{"type":"integer","format":"int32","default":0,"readOnly":false},"unit":{"$ref":"#/components/schemas/SchedulingUnit"},"time_zone":{"type":"string","readOnly":true},"end_hour":{"type":"integer","format":"int32","default":0,"readOnly":false},"value":{"type":"integer","format":"int32","default":0,"readOnly":false}},"required":["time_zone","unit","value"]},"SchedulingUnit":{"type":"string","enum":["MINUTE","HOUR","DAY"],"readOnly":false},"RelationshipCardinality":{"type":"string","enum":["ONE_TO_ONE","ONE_TO_ZERO_OR_ONE","ONE_TO_MANY"],"readOnly":false},"ObjectTreeDataSourceType":{"type":"string","enum":["DATA_WAREHOUSE","JSON_DATA_STREAM","PREDEFINED","EDGE","COMPUTED_FIELD"],"readOnly":false},"ObjectTreeChannelSourceResource":{"discriminator":{"propertyName":"type","mapping":{"STATIC":"#/components/schemas/Static1","MAPPING":"#/components/schemas/Mapping"}},"oneOf":[{"$ref":"#/components/schemas/Static1"},{"$ref":"#/components/schemas/Mapping"}],"properties":{"type":{"type":"string","enum":["STATIC","MAPPING"]}},"required":["type"]},"Static1":{"type":"object","properties":{"id":{"type":"string","readOnly":true},"channel_id":{"type":"string","readOnly":false}},"required":["channel_id"]},"Mapping":{"type":"object","properties":{"id":{"type":"string","readOnly":true},"column_id":{"type":"string","readOnly":false}},"required":["column_id"]},"ObjectTreeDataWarehouseLiveIngestionConfigResource":{"type":"object","properties":{"id":{"type":"string","readOnly":true},"datamart_id":{"type":"string","readOnly":false},"name":{"type":"string","readOnly":false},"status":{"$ref":"#/components/schemas/ObjectTreeDataWarehouseLiveIngestionStatus"},"object_tree_id":{"type":"string","readOnly":false},"creation_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"bucket_name":{"type":"string","readOnly":false},"data_warehouse_id":{"type":"string","readOnly":false}},"required":["bucket_name","creation_ts","data_warehouse_id","datamart_id","id","name","object_tree_id","status"]},"ObjectTreeDataWarehouseLiveIngestionStatus":{"type":"string","enum":["WAITING_FOR_TABLE_CREATION","PAUSED","ACTIVE"],"readOnly":false},"ObjectTypeDefinitionInfosResource":{"type":"object","properties":{"input_mapping_path":{"type":"string","readOnly":false},"update_value_object":{"type":"boolean","default":false,"readOnly":false},"object_name":{"type":"string","readOnly":false},"id":{"type":"string","readOnly":true},"relationships":{"type":"array","items":{"$ref":"#/components/schemas/RelationshipInfosResource"},"readOnly":false},"cloned_from":{"type":"string","readOnly":false},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/ObjectTypeMappingResource"},"readOnly":true},"fields":{"type":"array","items":{"$ref":"#/components/schemas/ScalarFieldInfosResource"},"readOnly":false},"input_mapping_table":{"type":"string","readOnly":false},"input_mapping_column":{"type":"string","readOnly":false}},"required":["fields","id","mappings","object_name","relationships","update_value_object"]},"RelationshipInfosResource":{"type":"object","properties":{"relation_name":{"type":"string","readOnly":false},"cloned_from":{"type":"string","readOnly":false},"cardinality":{"$ref":"#/components/schemas/RelationshipCardinality"},"id":{"type":"string","readOnly":true},"child":{"$ref":"#/components/schemas/ObjectTypeDefinitionInfosResource"}},"required":["cardinality","relation_name"]},"ObjectTypeMappingResource":{"discriminator":{"propertyName":"type","mapping":{"DATA_WAREHOUSE_COLUMN_BY_NAME":"#/components/schemas/DataWarehouseColumnByName1","DATA_WAREHOUSE_TABLE_BY_ID":"#/components/schemas/DataWarehouseTableById","JSON_PATH":"#/components/schemas/JsonPath1","DATA_WAREHOUSE_COLUMN_BY_ID":"#/components/schemas/DataWarehouseColumnById","DATA_WAREHOUSE_TABLE_BY_NAME":"#/components/schemas/DataWarehouseTableByName"}},"oneOf":[{"$ref":"#/components/schemas/DataWarehouseTableById"},{"$ref":"#/components/schemas/JsonPath1"},{"$ref":"#/components/schemas/DataWarehouseTableByName"},{"$ref":"#/components/schemas/DataWarehouseColumnByName1"},{"$ref":"#/components/schemas/DataWarehouseColumnById"}],"properties":{"type":{"type":"string","enum":["DATA_WAREHOUSE_TABLE_BY_ID","JSON_PATH","DATA_WAREHOUSE_TABLE_BY_NAME","DATA_WAREHOUSE_COLUMN_BY_NAME","DATA_WAREHOUSE_COLUMN_BY_ID"]}},"required":["type"]},"DataWarehouseTableById":{"type":"object","properties":{"table_id":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["mapping_group_id","table_id"]},"JsonPath1":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["json_path","mapping_group_id"]},"DataWarehouseTableByName":{"type":"object","properties":{"table_name":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["mapping_group_id","table_name"]},"DataWarehouseColumnByName1":{"type":"object","properties":{"column_name":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["column_name","mapping_group_id"]},"DataWarehouseColumnById":{"type":"object","properties":{"column_id":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["column_id","mapping_group_id"]},"ScalarFieldInfosResource":{"type":"object","properties":{"cloned_from":{"type":"string","readOnly":false},"input_mapping":{"$ref":"#/components/schemas/FieldInputMappingResource"},"field_name":{"type":"string","readOnly":false},"optional":{"type":"boolean","default":false,"readOnly":false},"primary_key":{"type":"boolean","default":false,"readOnly":false},"id":{"type":"string","readOnly":true},"tree_index_data_type":{"$ref":"#/components/schemas/TreeIndexDataType"},"foreign_key":{"$ref":"#/components/schemas/FieldRef"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/FieldMappingResource"},"readOnly":true},"field_type":{"type":"string","readOnly":false},"tree_index":{"$ref":"#/components/schemas/ObjectTreeIndexResource"},"reference_table":{"$ref":"#/components/schemas/ReferenceTableResource"},"list":{"type":"boolean","default":false,"readOnly":false},"predefined":{"type":"boolean","default":false,"readOnly":true}},"required":["field_name","field_type","list","mappings","optional","predefined","primary_key"]},"FieldInputMappingResource":{"discriminator":{"propertyName":"type","mapping":{"DATA_WAREHOUSE":"#/components/schemas/DataWarehouse","JSON_DATA_STREAM":"#/components/schemas/JsonDataStream","CONVERT_FROM":"#/components/schemas/ConvertFrom1"}},"oneOf":[{"$ref":"#/components/schemas/DataWarehouse"},{"$ref":"#/components/schemas/JsonDataStream"},{"$ref":"#/components/schemas/ConvertFrom1"}],"properties":{"type":{"type":"string","enum":["DATA_WAREHOUSE","JSON_DATA_STREAM","CONVERT_FROM"]}},"required":["type"]},"DataWarehouse":{"type":"object","properties":{"data_warehouse_column_id":{"type":"string","readOnly":false}},"required":["data_warehouse_column_id"]},"JsonDataStream":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false}},"required":["json_path"]},"ConvertFrom1":{"type":"object","properties":{"field":{"$ref":"#/components/schemas/FieldRef"},"source_unit":{"$ref":"#/components/schemas/TimestampUnit"}},"required":["field"]},"FieldRef":{"discriminator":{"propertyName":"type","mapping":{"FIELD_NAME":"#/components/schemas/FieldName","FIELD_ID":"#/components/schemas/FieldId1"}},"oneOf":[{"$ref":"#/components/schemas/FieldName"},{"$ref":"#/components/schemas/FieldId1"}],"properties":{"type":{"type":"string","enum":["FIELD_NAME","FIELD_ID"]}},"required":["type"]},"FieldName":{"type":"object","properties":{"field_name":{"type":"string","readOnly":false}},"required":["field_name"]},"FieldId1":{"type":"object","properties":{"field_id":{"type":"string","readOnly":false}},"required":["field_id"]},"TreeIndexDataType":{"type":"string","enum":["TEXT","KEYWORD"],"readOnly":false},"FieldMappingResource":{"discriminator":{"propertyName":"type","mapping":{"CONVERT_FROM":"#/components/schemas/ConvertFrom","DATA_WAREHOUSE_COLUMN_BY_NAME":"#/components/schemas/DataWarehouseColumnByName","JSON_DATA_STREAM":"#/components/schemas/JsonPath","DATA_WAREHOUSE_COLUMN_BY_ID":"#/components/schemas/DataWarehouseColumnById1","JSON_PATH":"#/components/schemas/JsonPath","AUTO_GENERATED":"#/components/schemas/AutoGenerated"}},"oneOf":[{"$ref":"#/components/schemas/JsonPath"},{"$ref":"#/components/schemas/AutoGenerated"},{"$ref":"#/components/schemas/JsonPath"},{"$ref":"#/components/schemas/ConvertFrom"},{"$ref":"#/components/schemas/DataWarehouseColumnByName"},{"$ref":"#/components/schemas/DataWarehouseColumnById1"}],"properties":{"type":{"type":"string","enum":["JSON_PATH","AUTO_GENERATED","JSON_DATA_STREAM","CONVERT_FROM","DATA_WAREHOUSE_COLUMN_BY_NAME","DATA_WAREHOUSE_COLUMN_BY_ID"]}},"required":["type"]},"JsonPath":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["json_path","mapping_group_id"]},"AutoGenerated":{"type":"object","properties":{"strategy":{"$ref":"#/components/schemas/AutoGeneratedStrategy"},"mapping_group_id":{"type":"string","readOnly":false}},"required":["mapping_group_id","strategy"]},"AutoGeneratedStrategy":{"type":"string","enum":["INDEX","UUID"],"readOnly":false},"ConvertFrom":{"type":"object","properties":{"field":{"$ref":"#/components/schemas/FieldRef"},"source_unit":{"$ref":"#/components/schemas/TimestampUnit"},"mapping_group_id":{"type":"string","readOnly":false}},"required":["field","mapping_group_id"]},"DataWarehouseColumnByName":{"type":"object","properties":{"column_name":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["column_name","mapping_group_id"]},"DataWarehouseColumnById1":{"type":"object","properties":{"data_warehouse_column_id":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["data_warehouse_column_id","mapping_group_id"]},"ObjectTreeIndexResource":{"type":"object","properties":{"id":{"type":"string","readOnly":false},"name":{"type":"string","readOnly":false}},"required":["name"]},"ReferenceTableResource":{"type":"object","properties":{"id":{"type":"string","readOnly":false},"type":{"$ref":"#/components/schemas/ReferenceTableType"},"model_type":{"type":"string","readOnly":false}},"required":["model_type","type"]},"ReferenceTableType":{"type":"string","enum":["CORE_OBJECT","STATIC","SYSTEM_ENUM","DISCOVERED"],"readOnly":false},"Generic":{"allOf":[{"$ref":"#/components/schemas/ObjectTreeIdentifierResource"},{"type":"object","properties":{"id":{"type":"string","readOnly":true},"main":{"type":"boolean","default":false,"readOnly":false},"realm_id":{"type":"string","readOnly":false},"location":{"$ref":"#/components/schemas/ObjectTreeIdentifierLocationResource"},"identifier_type":{"$ref":"#/components/schemas/IdentifierType"}},"required":["id","identifier_type","main"]}]},"ObjectTreeIdentifierResource":{"type":"object"},"ObjectTreeIdentifierLocationResource":{"discriminator":{"propertyName":"type","mapping":{"COLUMN_LOCATION":"#/components/schemas/ObjectTreeIdentifierColumnLocationResource","FIELD_LOCATION":"#/components/schemas/ObjectTreeIdentifierFieldLocationResource"}},"oneOf":[{"$ref":"#/components/schemas/ObjectTreeIdentifierColumnLocationResource"},{"$ref":"#/components/schemas/ObjectTreeIdentifierFieldLocationResource"}],"properties":{"type":{"type":"string","enum":["COLUMN_LOCATION","FIELD_LOCATION"]}},"required":["type"]},"ObjectTreeIdentifierColumnLocationResource":{"type":"object","properties":{"column_id":{"type":"string","readOnly":false}},"required":["column_id"]},"ObjectTreeIdentifierFieldLocationResource":{"type":"object","properties":{"field_id":{"type":"string","readOnly":false}},"required":["field_id"]},"IdentifierType":{"type":"string","enum":["EMAIL_HASH","USER_ACCOUNT","USER_POINT_ID","DEVICE_POINT","DEVICE_TECHNICAL_ID"],"readOnly":false},"ObjectTreeEventNameResource":{"discriminator":{"propertyName":"type","mapping":{"STATIC":"#/components/schemas/Static","MAPPING":"#/components/schemas/Mapping1"}},"oneOf":[{"$ref":"#/components/schemas/Static"},{"$ref":"#/components/schemas/Mapping1"}],"properties":{"type":{"type":"string","enum":["STATIC","MAPPING"]}},"required":["type"]},"Static":{"type":"object","properties":{"id":{"type":"string","readOnly":true},"event_name":{"type":"string","readOnly":false}},"required":["event_name"]},"Mapping1":{"type":"object","properties":{"id":{"type":"string","readOnly":true},"column_id":{"type":"string","readOnly":false}},"required":["column_id"]},"ObjectTreeType":{"type":"string","enum":["Custom","ClusteringCohort","UserAccount","UserActivity","UserChoice","UserDevicePoint","UserEmail","UserEvent","UserProfile","UserScenario","UserSegment"],"readOnly":false},"ObjectTreeActivityType":{"type":"string","enum":["TOUCH","SITE_VISIT","APP_VISIT","CTV_VISIT"],"readOnly":false},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## DELETE /datamarts/{datamart\_id}/graphdb\_runtime\_schemas/{schema\_id}/object\_trees/{object\_tree\_id}

> Delete object tree

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Runtime Schemas","description":"Operations related to **Runtime Schemas**, the GraphQL SDL configurations that define the data model of a Datamart, specifying which objects and fields are stored, structured, and indexed for querying. **Indexed fields** can be used in OTQL queries and segment building, while non-indexed fields remain stored but not queryable. Schema changes can be applied with historical data reindexing.\n\nRelevant documentation:\n- [Schema](https://userguides.mediarithmics.io/basics/key-concepts/what-is-a-data-schema)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/datamarts/{datamart_id}/graphdb_runtime_schemas/{schema_id}/object_trees/{object_tree_id}":{"delete":{"parameters":[{"name":"datamart_id","explode":false,"style":"simple","in":"path","schema":{"type":"string"},"required":true},{"required":true,"name":"schema_id","in":"path","schema":{"type":"string"},"explode":false,"style":"simple"},{"style":"simple","schema":{"type":"string"},"required":true,"in":"path","name":"object_tree_id","explode":false}],"description":"","tags":["Runtime Schemas"],"responses":{"200":{"$ref":"#/components/responses/simple"},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"summary":"Delete object tree","operationId":"deleteObjectTree"}}},"components":{"responses":{"simple":{"description":"Success response","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]}},"required":["status"]}}}},"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}},"schemas":{"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}}}}
```

## GET /datamarts/{datamart\_id}/graphdb\_runtime\_schemas/{schema\_id}/object\_types/{id}

> Get object type by id

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Runtime Schemas","description":"Operations related to **Runtime Schemas**, the GraphQL SDL configurations that define the data model of a Datamart, specifying which objects and fields are stored, structured, and indexed for querying. **Indexed fields** can be used in OTQL queries and segment building, while non-indexed fields remain stored but not queryable. Schema changes can be applied with historical data reindexing.\n\nRelevant documentation:\n- [Schema](https://userguides.mediarithmics.io/basics/key-concepts/what-is-a-data-schema)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/datamarts/{datamart_id}/graphdb_runtime_schemas/{schema_id}/object_types/{id}":{"get":{"parameters":[{"schema":{"type":"integer","format":"int64"},"explode":false,"in":"path","style":"simple","required":true,"name":"datamart_id"},{"required":true,"schema":{"type":"integer","format":"int64"},"style":"simple","name":"schema_id","in":"path","explode":false},{"style":"simple","name":"id","required":true,"in":"path","schema":{"type":"integer","format":"int64"},"explode":false}],"description":"","responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/ObjectLikeTypeResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"summary":"Get object type by id","tags":["Runtime Schemas"],"operationId":"getObjectType"}}},"components":{"schemas":{"ObjectLikeTypeResource":{"allOf":[{"$ref":"#/components/schemas/AbstractObjectLikeTypeResource"},{"type":"object","properties":{"id":{"type":"string","readOnly":true},"runtime_schema_id":{"type":"string","readOnly":true},"type":{"$ref":"#/components/schemas/ObjectLikeType"},"name":{"type":"string","readOnly":false}},"required":["id","name","runtime_schema_id","type"]}]},"AbstractObjectLikeTypeResource":{"type":"object"},"ObjectLikeType":{"type":"string","enum":["OBJECT_TYPE","INTERFACE_TYPE"],"readOnly":false},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## POST /datamarts/{datamart\_id}/graphdb\_runtime\_schemas/{schema\_id}/user\_agent\_mappings

> Enable or disable user agent mappings

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Runtime Schemas","description":"Operations related to **Runtime Schemas**, the GraphQL SDL configurations that define the data model of a Datamart, specifying which objects and fields are stored, structured, and indexed for querying. **Indexed fields** can be used in OTQL queries and segment building, while non-indexed fields remain stored but not queryable. Schema changes can be applied with historical data reindexing.\n\nRelevant documentation:\n- [Schema](https://userguides.mediarithmics.io/basics/key-concepts/what-is-a-data-schema)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/datamarts/{datamart_id}/graphdb_runtime_schemas/{schema_id}/user_agent_mappings":{"post":{"responses":{"200":{"$ref":"#/components/responses/simple"},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"description":"","tags":["Runtime Schemas"],"operationId":"setupUserAgentMappings","parameters":[{"explode":false,"in":"path","style":"simple","name":"datamart_id","schema":{"type":"string"},"required":true},{"schema":{"type":"string"},"explode":false,"name":"schema_id","in":"path","required":true,"style":"simple"}],"summary":"Enable or disable user agent mappings","requestBody":{"description":"The action to perform","content":{"application/json":{"schema":{"$ref":"#/components/schemas/UserAgentMappingActionRequest"}}},"required":true}}}},"components":{"responses":{"simple":{"description":"Success response","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]}},"required":["status"]}}}},"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}},"schemas":{"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]},"UserAgentMappingActionRequest":{"type":"object","properties":{"action":{"$ref":"#/components/schemas/PredefinedObjectTreeAction"}},"required":["action"]},"PredefinedObjectTreeAction":{"type":"string","enum":["ENABLE","DISABLE"],"readOnly":false}}}}
```

## GET /datamarts/{datamart\_id}/graphdb\_runtime\_schemas/{schema\_id}/object\_trees/{object\_tree\_id}/object\_type\_definitions/{object\_type\_definition\_id}/relationships/{relationship\_id}

> Get object tree relationship

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Runtime Schemas","description":"Operations related to **Runtime Schemas**, the GraphQL SDL configurations that define the data model of a Datamart, specifying which objects and fields are stored, structured, and indexed for querying. **Indexed fields** can be used in OTQL queries and segment building, while non-indexed fields remain stored but not queryable. Schema changes can be applied with historical data reindexing.\n\nRelevant documentation:\n- [Schema](https://userguides.mediarithmics.io/basics/key-concepts/what-is-a-data-schema)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/datamarts/{datamart_id}/graphdb_runtime_schemas/{schema_id}/object_trees/{object_tree_id}/object_type_definitions/{object_type_definition_id}/relationships/{relationship_id}":{"get":{"description":"","parameters":[{"name":"datamart_id","style":"simple","explode":false,"schema":{"type":"string"},"in":"path","required":true},{"name":"schema_id","required":true,"schema":{"type":"string"},"explode":false,"in":"path","style":"simple"},{"style":"simple","in":"path","explode":false,"schema":{"type":"string"},"required":true,"name":"object_tree_id"},{"style":"simple","required":true,"in":"path","name":"object_type_definition_id","explode":false,"schema":{"type":"string"}},{"schema":{"type":"string"},"explode":false,"in":"path","style":"simple","name":"relationship_id","required":true}],"responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/RelationshipInfosResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"tags":["Runtime Schemas"],"operationId":"getObjectTreeRelationship","summary":"Get object tree relationship"}}},"components":{"schemas":{"RelationshipInfosResource":{"type":"object","properties":{"relation_name":{"type":"string","readOnly":false},"cloned_from":{"type":"string","readOnly":false},"cardinality":{"$ref":"#/components/schemas/RelationshipCardinality"},"id":{"type":"string","readOnly":true},"child":{"$ref":"#/components/schemas/ObjectTypeDefinitionInfosResource"}},"required":["cardinality","relation_name"]},"RelationshipCardinality":{"type":"string","enum":["ONE_TO_ONE","ONE_TO_ZERO_OR_ONE","ONE_TO_MANY"],"readOnly":false},"ObjectTypeDefinitionInfosResource":{"type":"object","properties":{"input_mapping_path":{"type":"string","readOnly":false},"update_value_object":{"type":"boolean","default":false,"readOnly":false},"object_name":{"type":"string","readOnly":false},"id":{"type":"string","readOnly":true},"relationships":{"type":"array","items":{"$ref":"#/components/schemas/RelationshipInfosResource"},"readOnly":false},"cloned_from":{"type":"string","readOnly":false},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/ObjectTypeMappingResource"},"readOnly":true},"fields":{"type":"array","items":{"$ref":"#/components/schemas/ScalarFieldInfosResource"},"readOnly":false},"input_mapping_table":{"type":"string","readOnly":false},"input_mapping_column":{"type":"string","readOnly":false}},"required":["fields","id","mappings","object_name","relationships","update_value_object"]},"ObjectTypeMappingResource":{"discriminator":{"propertyName":"type","mapping":{"DATA_WAREHOUSE_COLUMN_BY_NAME":"#/components/schemas/DataWarehouseColumnByName1","DATA_WAREHOUSE_TABLE_BY_ID":"#/components/schemas/DataWarehouseTableById","JSON_PATH":"#/components/schemas/JsonPath1","DATA_WAREHOUSE_COLUMN_BY_ID":"#/components/schemas/DataWarehouseColumnById","DATA_WAREHOUSE_TABLE_BY_NAME":"#/components/schemas/DataWarehouseTableByName"}},"oneOf":[{"$ref":"#/components/schemas/DataWarehouseTableById"},{"$ref":"#/components/schemas/JsonPath1"},{"$ref":"#/components/schemas/DataWarehouseTableByName"},{"$ref":"#/components/schemas/DataWarehouseColumnByName1"},{"$ref":"#/components/schemas/DataWarehouseColumnById"}],"properties":{"type":{"type":"string","enum":["DATA_WAREHOUSE_TABLE_BY_ID","JSON_PATH","DATA_WAREHOUSE_TABLE_BY_NAME","DATA_WAREHOUSE_COLUMN_BY_NAME","DATA_WAREHOUSE_COLUMN_BY_ID"]}},"required":["type"]},"DataWarehouseTableById":{"type":"object","properties":{"table_id":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["mapping_group_id","table_id"]},"JsonPath1":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["json_path","mapping_group_id"]},"DataWarehouseTableByName":{"type":"object","properties":{"table_name":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["mapping_group_id","table_name"]},"DataWarehouseColumnByName1":{"type":"object","properties":{"column_name":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["column_name","mapping_group_id"]},"DataWarehouseColumnById":{"type":"object","properties":{"column_id":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["column_id","mapping_group_id"]},"ScalarFieldInfosResource":{"type":"object","properties":{"cloned_from":{"type":"string","readOnly":false},"input_mapping":{"$ref":"#/components/schemas/FieldInputMappingResource"},"field_name":{"type":"string","readOnly":false},"optional":{"type":"boolean","default":false,"readOnly":false},"primary_key":{"type":"boolean","default":false,"readOnly":false},"id":{"type":"string","readOnly":true},"tree_index_data_type":{"$ref":"#/components/schemas/TreeIndexDataType"},"foreign_key":{"$ref":"#/components/schemas/FieldRef"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/FieldMappingResource"},"readOnly":true},"field_type":{"type":"string","readOnly":false},"tree_index":{"$ref":"#/components/schemas/ObjectTreeIndexResource"},"reference_table":{"$ref":"#/components/schemas/ReferenceTableResource"},"list":{"type":"boolean","default":false,"readOnly":false},"predefined":{"type":"boolean","default":false,"readOnly":true}},"required":["field_name","field_type","list","mappings","optional","predefined","primary_key"]},"FieldInputMappingResource":{"discriminator":{"propertyName":"type","mapping":{"DATA_WAREHOUSE":"#/components/schemas/DataWarehouse","JSON_DATA_STREAM":"#/components/schemas/JsonDataStream","CONVERT_FROM":"#/components/schemas/ConvertFrom1"}},"oneOf":[{"$ref":"#/components/schemas/DataWarehouse"},{"$ref":"#/components/schemas/JsonDataStream"},{"$ref":"#/components/schemas/ConvertFrom1"}],"properties":{"type":{"type":"string","enum":["DATA_WAREHOUSE","JSON_DATA_STREAM","CONVERT_FROM"]}},"required":["type"]},"DataWarehouse":{"type":"object","properties":{"data_warehouse_column_id":{"type":"string","readOnly":false}},"required":["data_warehouse_column_id"]},"JsonDataStream":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false}},"required":["json_path"]},"ConvertFrom1":{"type":"object","properties":{"field":{"$ref":"#/components/schemas/FieldRef"},"source_unit":{"$ref":"#/components/schemas/TimestampUnit"}},"required":["field"]},"FieldRef":{"discriminator":{"propertyName":"type","mapping":{"FIELD_NAME":"#/components/schemas/FieldName","FIELD_ID":"#/components/schemas/FieldId1"}},"oneOf":[{"$ref":"#/components/schemas/FieldName"},{"$ref":"#/components/schemas/FieldId1"}],"properties":{"type":{"type":"string","enum":["FIELD_NAME","FIELD_ID"]}},"required":["type"]},"FieldName":{"type":"object","properties":{"field_name":{"type":"string","readOnly":false}},"required":["field_name"]},"FieldId1":{"type":"object","properties":{"field_id":{"type":"string","readOnly":false}},"required":["field_id"]},"TimestampUnit":{"type":"string","enum":["SECOND","MILLISECOND","MICROSECOND","NANOSECOND"],"readOnly":false},"TreeIndexDataType":{"type":"string","enum":["TEXT","KEYWORD"],"readOnly":false},"FieldMappingResource":{"discriminator":{"propertyName":"type","mapping":{"CONVERT_FROM":"#/components/schemas/ConvertFrom","DATA_WAREHOUSE_COLUMN_BY_NAME":"#/components/schemas/DataWarehouseColumnByName","JSON_DATA_STREAM":"#/components/schemas/JsonPath","DATA_WAREHOUSE_COLUMN_BY_ID":"#/components/schemas/DataWarehouseColumnById1","JSON_PATH":"#/components/schemas/JsonPath","AUTO_GENERATED":"#/components/schemas/AutoGenerated"}},"oneOf":[{"$ref":"#/components/schemas/JsonPath"},{"$ref":"#/components/schemas/AutoGenerated"},{"$ref":"#/components/schemas/JsonPath"},{"$ref":"#/components/schemas/ConvertFrom"},{"$ref":"#/components/schemas/DataWarehouseColumnByName"},{"$ref":"#/components/schemas/DataWarehouseColumnById1"}],"properties":{"type":{"type":"string","enum":["JSON_PATH","AUTO_GENERATED","JSON_DATA_STREAM","CONVERT_FROM","DATA_WAREHOUSE_COLUMN_BY_NAME","DATA_WAREHOUSE_COLUMN_BY_ID"]}},"required":["type"]},"JsonPath":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["json_path","mapping_group_id"]},"AutoGenerated":{"type":"object","properties":{"strategy":{"$ref":"#/components/schemas/AutoGeneratedStrategy"},"mapping_group_id":{"type":"string","readOnly":false}},"required":["mapping_group_id","strategy"]},"AutoGeneratedStrategy":{"type":"string","enum":["INDEX","UUID"],"readOnly":false},"ConvertFrom":{"type":"object","properties":{"field":{"$ref":"#/components/schemas/FieldRef"},"source_unit":{"$ref":"#/components/schemas/TimestampUnit"},"mapping_group_id":{"type":"string","readOnly":false}},"required":["field","mapping_group_id"]},"DataWarehouseColumnByName":{"type":"object","properties":{"column_name":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["column_name","mapping_group_id"]},"DataWarehouseColumnById1":{"type":"object","properties":{"data_warehouse_column_id":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["data_warehouse_column_id","mapping_group_id"]},"ObjectTreeIndexResource":{"type":"object","properties":{"id":{"type":"string","readOnly":false},"name":{"type":"string","readOnly":false}},"required":["name"]},"ReferenceTableResource":{"type":"object","properties":{"id":{"type":"string","readOnly":false},"type":{"$ref":"#/components/schemas/ReferenceTableType"},"model_type":{"type":"string","readOnly":false}},"required":["model_type","type"]},"ReferenceTableType":{"type":"string","enum":["CORE_OBJECT","STATIC","SYSTEM_ENUM","DISCOVERED"],"readOnly":false},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## PUT /datamarts/{datamart\_id}/graphdb\_runtime\_schemas/{schema\_id}/object\_trees/{object\_tree\_id}/object\_type\_definitions/{object\_type\_definition\_id}/relationships/{relationship\_id}

> Update object tree relationship

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Runtime Schemas","description":"Operations related to **Runtime Schemas**, the GraphQL SDL configurations that define the data model of a Datamart, specifying which objects and fields are stored, structured, and indexed for querying. **Indexed fields** can be used in OTQL queries and segment building, while non-indexed fields remain stored but not queryable. Schema changes can be applied with historical data reindexing.\n\nRelevant documentation:\n- [Schema](https://userguides.mediarithmics.io/basics/key-concepts/what-is-a-data-schema)\n"}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/datamarts/{datamart_id}/graphdb_runtime_schemas/{schema_id}/object_trees/{object_tree_id}/object_type_definitions/{object_type_definition_id}/relationships/{relationship_id}":{"put":{"responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/RelationshipInfosResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"requestBody":{"description":"The relationship to update","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RelationshipInfosResource"}}},"required":true},"parameters":[{"name":"datamart_id","schema":{"type":"string"},"in":"path","required":true,"style":"simple","explode":false},{"explode":false,"required":true,"schema":{"type":"string"},"style":"simple","name":"schema_id","in":"path"},{"schema":{"type":"string"},"in":"path","required":true,"explode":false,"name":"object_tree_id","style":"simple"},{"schema":{"type":"string"},"required":true,"in":"path","name":"object_type_definition_id","style":"simple","explode":false},{"style":"simple","required":true,"schema":{"type":"string"},"explode":false,"in":"path","name":"relationship_id"}],"description":"","tags":["Runtime Schemas"],"operationId":"updateObjectTreeRelationship","summary":"Update object tree relationship"}}},"components":{"schemas":{"RelationshipInfosResource":{"type":"object","properties":{"relation_name":{"type":"string","readOnly":false},"cloned_from":{"type":"string","readOnly":false},"cardinality":{"$ref":"#/components/schemas/RelationshipCardinality"},"id":{"type":"string","readOnly":true},"child":{"$ref":"#/components/schemas/ObjectTypeDefinitionInfosResource"}},"required":["cardinality","relation_name"]},"RelationshipCardinality":{"type":"string","enum":["ONE_TO_ONE","ONE_TO_ZERO_OR_ONE","ONE_TO_MANY"],"readOnly":false},"ObjectTypeDefinitionInfosResource":{"type":"object","properties":{"input_mapping_path":{"type":"string","readOnly":false},"update_value_object":{"type":"boolean","default":false,"readOnly":false},"object_name":{"type":"string","readOnly":false},"id":{"type":"string","readOnly":true},"relationships":{"type":"array","items":{"$ref":"#/components/schemas/RelationshipInfosResource"},"readOnly":false},"cloned_from":{"type":"string","readOnly":false},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/ObjectTypeMappingResource"},"readOnly":true},"fields":{"type":"array","items":{"$ref":"#/components/schemas/ScalarFieldInfosResource"},"readOnly":false},"input_mapping_table":{"type":"string","readOnly":false},"input_mapping_column":{"type":"string","readOnly":false}},"required":["fields","id","mappings","object_name","relationships","update_value_object"]},"ObjectTypeMappingResource":{"discriminator":{"propertyName":"type","mapping":{"DATA_WAREHOUSE_COLUMN_BY_NAME":"#/components/schemas/DataWarehouseColumnByName1","DATA_WAREHOUSE_TABLE_BY_ID":"#/components/schemas/DataWarehouseTableById","JSON_PATH":"#/components/schemas/JsonPath1","DATA_WAREHOUSE_COLUMN_BY_ID":"#/components/schemas/DataWarehouseColumnById","DATA_WAREHOUSE_TABLE_BY_NAME":"#/components/schemas/DataWarehouseTableByName"}},"oneOf":[{"$ref":"#/components/schemas/DataWarehouseTableById"},{"$ref":"#/components/schemas/JsonPath1"},{"$ref":"#/components/schemas/DataWarehouseTableByName"},{"$ref":"#/components/schemas/DataWarehouseColumnByName1"},{"$ref":"#/components/schemas/DataWarehouseColumnById"}],"properties":{"type":{"type":"string","enum":["DATA_WAREHOUSE_TABLE_BY_ID","JSON_PATH","DATA_WAREHOUSE_TABLE_BY_NAME","DATA_WAREHOUSE_COLUMN_BY_NAME","DATA_WAREHOUSE_COLUMN_BY_ID"]}},"required":["type"]},"DataWarehouseTableById":{"type":"object","properties":{"table_id":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["mapping_group_id","table_id"]},"JsonPath1":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["json_path","mapping_group_id"]},"DataWarehouseTableByName":{"type":"object","properties":{"table_name":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["mapping_group_id","table_name"]},"DataWarehouseColumnByName1":{"type":"object","properties":{"column_name":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["column_name","mapping_group_id"]},"DataWarehouseColumnById":{"type":"object","properties":{"column_id":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["column_id","mapping_group_id"]},"ScalarFieldInfosResource":{"type":"object","properties":{"cloned_from":{"type":"string","readOnly":false},"input_mapping":{"$ref":"#/components/schemas/FieldInputMappingResource"},"field_name":{"type":"string","readOnly":false},"optional":{"type":"boolean","default":false,"readOnly":false},"primary_key":{"type":"boolean","default":false,"readOnly":false},"id":{"type":"string","readOnly":true},"tree_index_data_type":{"$ref":"#/components/schemas/TreeIndexDataType"},"foreign_key":{"$ref":"#/components/schemas/FieldRef"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/FieldMappingResource"},"readOnly":true},"field_type":{"type":"string","readOnly":false},"tree_index":{"$ref":"#/components/schemas/ObjectTreeIndexResource"},"reference_table":{"$ref":"#/components/schemas/ReferenceTableResource"},"list":{"type":"boolean","default":false,"readOnly":false},"predefined":{"type":"boolean","default":false,"readOnly":true}},"required":["field_name","field_type","list","mappings","optional","predefined","primary_key"]},"FieldInputMappingResource":{"discriminator":{"propertyName":"type","mapping":{"DATA_WAREHOUSE":"#/components/schemas/DataWarehouse","JSON_DATA_STREAM":"#/components/schemas/JsonDataStream","CONVERT_FROM":"#/components/schemas/ConvertFrom1"}},"oneOf":[{"$ref":"#/components/schemas/DataWarehouse"},{"$ref":"#/components/schemas/JsonDataStream"},{"$ref":"#/components/schemas/ConvertFrom1"}],"properties":{"type":{"type":"string","enum":["DATA_WAREHOUSE","JSON_DATA_STREAM","CONVERT_FROM"]}},"required":["type"]},"DataWarehouse":{"type":"object","properties":{"data_warehouse_column_id":{"type":"string","readOnly":false}},"required":["data_warehouse_column_id"]},"JsonDataStream":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false}},"required":["json_path"]},"ConvertFrom1":{"type":"object","properties":{"field":{"$ref":"#/components/schemas/FieldRef"},"source_unit":{"$ref":"#/components/schemas/TimestampUnit"}},"required":["field"]},"FieldRef":{"discriminator":{"propertyName":"type","mapping":{"FIELD_NAME":"#/components/schemas/FieldName","FIELD_ID":"#/components/schemas/FieldId1"}},"oneOf":[{"$ref":"#/components/schemas/FieldName"},{"$ref":"#/components/schemas/FieldId1"}],"properties":{"type":{"type":"string","enum":["FIELD_NAME","FIELD_ID"]}},"required":["type"]},"FieldName":{"type":"object","properties":{"field_name":{"type":"string","readOnly":false}},"required":["field_name"]},"FieldId1":{"type":"object","properties":{"field_id":{"type":"string","readOnly":false}},"required":["field_id"]},"TimestampUnit":{"type":"string","enum":["SECOND","MILLISECOND","MICROSECOND","NANOSECOND"],"readOnly":false},"TreeIndexDataType":{"type":"string","enum":["TEXT","KEYWORD"],"readOnly":false},"FieldMappingResource":{"discriminator":{"propertyName":"type","mapping":{"CONVERT_FROM":"#/components/schemas/ConvertFrom","DATA_WAREHOUSE_COLUMN_BY_NAME":"#/components/schemas/DataWarehouseColumnByName","JSON_DATA_STREAM":"#/components/schemas/JsonPath","DATA_WAREHOUSE_COLUMN_BY_ID":"#/components/schemas/DataWarehouseColumnById1","JSON_PATH":"#/components/schemas/JsonPath","AUTO_GENERATED":"#/components/schemas/AutoGenerated"}},"oneOf":[{"$ref":"#/components/schemas/JsonPath"},{"$ref":"#/components/schemas/AutoGenerated"},{"$ref":"#/components/schemas/JsonPath"},{"$ref":"#/components/schemas/ConvertFrom"},{"$ref":"#/components/schemas/DataWarehouseColumnByName"},{"$ref":"#/components/schemas/DataWarehouseColumnById1"}],"properties":{"type":{"type":"string","enum":["JSON_PATH","AUTO_GENERATED","JSON_DATA_STREAM","CONVERT_FROM","DATA_WAREHOUSE_COLUMN_BY_NAME","DATA_WAREHOUSE_COLUMN_BY_ID"]}},"required":["type"]},"JsonPath":{"type":"object","properties":{"json_path":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["json_path","mapping_group_id"]},"AutoGenerated":{"type":"object","properties":{"strategy":{"$ref":"#/components/schemas/AutoGeneratedStrategy"},"mapping_group_id":{"type":"string","readOnly":false}},"required":["mapping_group_id","strategy"]},"AutoGeneratedStrategy":{"type":"string","enum":["INDEX","UUID"],"readOnly":false},"ConvertFrom":{"type":"object","properties":{"field":{"$ref":"#/components/schemas/FieldRef"},"source_unit":{"$ref":"#/components/schemas/TimestampUnit"},"mapping_group_id":{"type":"string","readOnly":false}},"required":["field","mapping_group_id"]},"DataWarehouseColumnByName":{"type":"object","properties":{"column_name":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["column_name","mapping_group_id"]},"DataWarehouseColumnById1":{"type":"object","properties":{"data_warehouse_column_id":{"type":"string","readOnly":false},"mapping_group_id":{"type":"string","readOnly":false}},"required":["data_warehouse_column_id","mapping_group_id"]},"ObjectTreeIndexResource":{"type":"object","properties":{"id":{"type":"string","readOnly":false},"name":{"type":"string","readOnly":false}},"required":["name"]},"ReferenceTableResource":{"type":"object","properties":{"id":{"type":"string","readOnly":false},"type":{"$ref":"#/components/schemas/ReferenceTableType"},"model_type":{"type":"string","readOnly":false}},"required":["model_type","type"]},"ReferenceTableType":{"type":"string","enum":["CORE_OBJECT","STATIC","SYSTEM_ENUM","DISCOVERED"],"readOnly":false},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## DELETE /datamarts/{datamart\_id}/graphdb\_runtime\_schemas/{schema\_id}/object\_trees/{object\_tree\_id}/object\_type\_definitions/{object\_type\_definition\_id}/relationships/{relationship\_id}

> Delete object tree relationship

```json
[...]
